package framework.everywaretechnologies.it.icarusandroid;

import android.content.SharedPreferences;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.Switch;

import framework.everywaretechnologies.it.icarus.Icarus;
import framework.everywaretechnologies.it.icarus.UserSettingsResource;


//classe di test Icarus framework

public class MainActivity extends AppCompatActivity {

    private final static String CLASS_NAME="MainActivity";

    private SharedPreferences myPrefs;
    private boolean lastBoolPref;
    private int lastIntPref;

    private Switch enteredExitedScreenTrackSwitch;
    private Switch boolPrefSwitch;
    private Switch intPrefSwitch;
    private Icarus instance;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        instance=Icarus.getInstance(MainActivity.this);
        instance.setApplicationContext(getApplicationContext());

        enteredExitedScreenTrackSwitch=findViewById(R.id.entered_exited_screen_track_switch);
        boolPrefSwitch=findViewById(R.id.pref_bool_switch);
        intPrefSwitch=findViewById(R.id.pref_int_switch);

        //creo due sharedPreferences fittizie per poter testare il cambio di pref di Icarus
        myPrefs=getSharedPreferences("MyPref",0);
        lastBoolPref=myPrefs.getBoolean("boolPref",false);
        lastIntPref=myPrefs.getInt("intPref",-1);

        //setto gli switch in base allo stato nelle shared preferences
        if(lastBoolPref) boolPrefSwitch.setChecked(true);
        else boolPrefSwitch.setChecked(false);

        if(lastIntPref==1)intPrefSwitch.setChecked(false);
        else intPrefSwitch.setChecked(true);
    }

    //------------------------- UI EVENT -----------------------
    public void onBtnScreenEventTrack(View view){

        Log.d(CLASS_NAME,"on btn screen event track");

        String eventType=null;
        if(enteredExitedScreenTrackSwitch.isChecked())
            eventType=enteredExitedScreenTrackSwitch.getTextOn().toString();
        else
            eventType=enteredExitedScreenTrackSwitch.getTextOff().toString();

        instance.trackScreen(MainActivity.this,eventType);
    }

    public void onBtnUserPrefChanges(View view){

        Log.d(CLASS_NAME,"on btn log user changes");

        //prendo i valori degli switch
        boolean boolSwitchValue;
        int intSwitchValue;

        if(boolPrefSwitch.isChecked()) boolSwitchValue=Boolean.valueOf(boolPrefSwitch.getTextOn().toString());
        else boolSwitchValue=Boolean.valueOf(boolPrefSwitch.getTextOff().toString());

        if(intPrefSwitch.isChecked()) intSwitchValue=Integer.valueOf(intPrefSwitch.getTextOn().toString());
        else intSwitchValue=Integer.valueOf(intPrefSwitch.getTextOff().toString());

        UserSettingsResource userSettingsResource=new UserSettingsResource(myPrefs,MainActivity.this);

        userSettingsResource.addBoolean("boolPref",boolSwitchValue);
        userSettingsResource.addInt("intPref",intSwitchValue);

        instance.logUserSettings(userSettingsResource);
    }
}
